#property copyright ""
#property version   "1.0"
#property link      "mah"

#property indicator_separate_window
#include <MovingAverages.mqh>
#property indicator_buffers 2
#property indicator_plots   2
#property indicator_type1   DRAW_HISTOGRAM
#property indicator_color1  clrOrange
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  2


//=================================================================//
input string                 Section_1           = "======== General Setting";
input int                    overPerc            = 60;
input bool                   AlertsOn            = false;          // Alerting 
input bool                   AlertsMessage       = false;           // Show alert message
input bool                   AlertsSound         = false;          // Play alert sound
input bool                   AlertsEmail         = false;          // Send email message
input string                 Section_2           = "======== Periods Setting";
input int                    period1             = 14;
input int                    period2             = 11;
        
//=================================================================//
//                     global parameters                           ||
//=================================================================//

       color                 cocci1;

       string                cci1,
                             short_name          ="mah";   

       double                cciValue1[],maValue1[],

                             ucci1,
                             dcci1;

       int                   handle_cciValue1,handle_maValue1;

//=================================================================//
//             Custom indicator initialization function            ||
//=================================================================//
int OnInit()
{
   SetIndexBuffer(0, maValue1,  INDICATOR_DATA);
   SetIndexBuffer(1, cciValue1, INDICATOR_DATA);
                ArraySetAsSeries(cciValue1, true);   
                ArraySetAsSeries(maValue1, true);   
   
  
     handle_cciValue1  =  iCCI(_Symbol, _Period, period1, 0); 
     
     if (handle_cciValue1< 0)
     {
         Alert (" wrong load indicators!!! ");
         return(-1);
     }


//------

  return(0);
}
//=================================================================//
//                            delete                               ||
//=================================================================//
void OnDeinit(const int reason)
{
    IndicatorRelease(handle_cciValue1);
   


}
//=================================================================//
//              Custom indicator iteration function                ||
//=================================================================//
int OnCalculate(const int       rates_total,
                const int       prev_calculated,
                const datetime  &time[],
                const double    &open[],
                const double    &high[],
                const double    &low[],
                const double    &close[],
                const long      &tick_volume[],
                const long      &volume[],
                const int       &spread[])
{

//-------
  int window = ChartWindowFind();
      checkObject(window,"cci1" , 50,15);
      
    
   
/////////////////////


//==================
//-------

                if(CopyBuffer   (handle_cciValue1, 0, 0, (int)MathMin(rates_total-prev_calculated+2,rates_total), cciValue1) < 0)
                return(0);

//-------

      SimpleMAOnBuffer(rates_total, prev_calculated, period1+period2, period2, cciValue1, maValue1);
   
//-------

//==================
//-------
//---
               if      (cciValue1[0] > maValue1[0])  {cci1 = " 0 "; cocci1 = Blue;    ucci1 = 1; dcci1 = 0;}
               else if (cciValue1[0] < maValue1[0])  {cci1 = " 0 "; cocci1 = Red;     ucci1 = 0; dcci1 = 1;}
               else {cci1 = " 0 "; cocci1 = Yellow;  ucci1 = 0; dcci1 = 0;}               
   
//==================
//-------



//---

   ObjectSetString (0, "cci1", OBJPROP_TEXT, cci1);
   ObjectSetInteger(0, "cci1", OBJPROP_FONTSIZE, 11);
   ObjectSetString (0, "cci1", OBJPROP_FONT, "Verdana");
   ObjectSetInteger(0, "cci1", OBJPROP_COLOR, cocci1);

           
//---

//-------


   return(rates_total);
}


void checkObject(int window,string name, int xpos, int ypos)
{
      ObjectCreate    (0,name,OBJ_LABEL,window,0,0);
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE, xpos);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE, ypos);
}




void doAlert(datetime& previousTime, string& previousAlert,datetime time, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != time) {
       previousAlert  = doWhat;
       previousTime   = time;

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToString(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" mah",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}


//=================================================================//
//                           Find_tf                               ||
//=================================================================//
int Find_tf(ENUM_TIMEFRAMES tf)
{
  switch(tf)
   {
     case PERIOD_M1:
             return(1);
     case PERIOD_M2:
             return(2);
     case PERIOD_M3:
             return(3);
     case PERIOD_M4:
             return(4);
     case PERIOD_M5:
             return(5);
     case PERIOD_M6:
             return(6);
     case PERIOD_M10:
             return(10);
     case PERIOD_M12:
             return(12);
     case PERIOD_M15:
             return(15);
     case PERIOD_M30:
             return(30);
     case PERIOD_H1:
             return(60);
     case PERIOD_H2:
             return(120);
     case PERIOD_H3:
             return(180);
     case PERIOD_H4:
             return(240);
     case PERIOD_H6:
             return(360);
     case PERIOD_H8:
             return(480);
     case PERIOD_H12:
             return(720);
     case PERIOD_D1:
             return(1440);
     case PERIOD_W1:
             return(10080);
     case PERIOD_MN1:
             return(43200);
     default:
             return(0);
   }
}